SystemOrganization addCategory: #'Ma exception handling-exceptions'!
SystemOrganization addCategory: #'Ma exception handling-Dynamic input'!
SystemOrganization addCategory: #'Ma exception handling-Requests'!

Notification subclass: #MaNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

MaNotification subclass: #MaNetworkNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaNotification methodsFor: 'as yet unclassified' stamp: 'cmm 3/28/2005 21:52'!
messageText

	^super messageText ifNil: [ self species name, ' - no detailed message available' ]! !

!Exception class methodsFor: '*ma exception handling' stamp: 'cmm 9/18/2005 23:56'!
messageText: aString

	^ self new
		messageText: aString ;
		yourself! !

!Exception methodsFor: '*ma exception handling' stamp: 'cmm 8/11/2002 23:35'!
maIsException

	^true! !

Exception subclass: #MaRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-Requests'!

MaRequest subclass: #MaStringRequest
	instanceVariableNames: 'initialAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-Requests'!

!MaStringRequest commentStamp: 'cmm 10/9/2005 12:01' prior: 0!
Some applications need to prompt the user for a String at an inopportune time; for example some operations may require the users privateKey file and we want to do this on a JIT basis.

The purpose of this class is to provide a default way to ask the user for a String while allowing programs to override with their own approach.!

MaStringRequest subclass: #MaFileRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-Requests'!

!MaFileRequest class methodsFor: 'create' stamp: 'cmm 11/16/2005 22:11'!
message: aString filename: filenameString initialDirectory: aFileDirectory

	^ self new
		messageText: aString, '.  Where is ', filenameString, '?' ;
		initialAnswer: aFileDirectory fullName ;
		yourself! !

!MaStringRequest class methodsFor: 'create' stamp: 'cmm 9/27/2005 00:49'!
messageText: messageString initialAnswer: initialAnswerString

	^ (self messageText: messageString) 
		initialAnswer: initialAnswerString ;
		yourself! !

!MaStringRequest methodsFor: 'initialize-release' stamp: 'cmm 11/16/2005 22:29'!
defaultAction
	self resume:
		(FillInTheBlank 
			request: self messageText
			initialAnswer: self initialAnswer)! !

!MaStringRequest methodsFor: 'accessing' stamp: 'cmm 9/27/2005 00:46'!
initialAnswer
	^ initialAnswer ifNil: [ String maEmpty ]! !

!MaStringRequest methodsFor: 'initialize-release' stamp: 'cmm 9/27/2005 00:49'!
initialAnswer: aString
	initialAnswer := aString! !

Error subclass: #MaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaError commentStamp: '<historical>' prior: 0!
Base abstraction for errors that occur in Ma code.!

MaError subclass: #MaCorruptionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

MaError subclass: #MaEnvironmentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

MaEnvironmentError subclass: #MaNetworkError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaError methodsFor: 'as yet unclassified' stamp: 'cmm 2/25/2003 18:02'!
isUserError

	^false! !

MaError subclass: #MaSecurityViolation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

MaError subclass: #MaSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaSoftwareError commentStamp: 'cmm 5/4/2005 10:25' prior: 0!
A software error is a bug in the software.  Signal them when you have to code for something that "should never happen."  For example, if, based on your program logic, there should be an entry in a Dictionary, but it is not there, you would signal a software error.!

MaError subclass: #MaUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaUserError commentStamp: '<historical>' prior: 0!
I represent an error made by the user.!

!MaUserError methodsFor: 'as yet unclassified' stamp: 'cmm 2/25/2003 18:01'!
isUserError

	^true! !

!Object methodsFor: '*ma exception handling' stamp: 'cmm 2/15/2002 00:02'!
maIsException

	^false
! !

Warning subclass: #MaWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!
